﻿Imports System.Net.Sockets

Module Module1
    Public Client As UdpClient
    Public RemoteIpEndPoint As New System.Net.IPEndPoint(System.Net.IPAddress.Any, 0) 'any ip we dont care
    Public ThreadReceive As System.Threading.Thread
    Public MyPort As Integer = 4123

    Sub Main()
        'set client
        Client = New System.Net.Sockets.UdpClient(MyPort)
        'start thread loop
        ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
        ThreadReceive.Start()
    End Sub

    'Used by GameEngine to Process Incoming UDP Packets.
    Private MyOutsim_Internal As New OutSim
    Private Structure OutSim
        '   time in milliseconds
        Public bytTime1 As Byte
        Public bytTime2 As Byte
        Public bytTime3 As Byte
        Public bytTime4 As Byte
        '   Angular Velocity
        Public sngAVelocity0 As Single
        Public sngAVelocity1 As Single
        Public sngAVelocity2 As Single
        '   Orientation
        Public sngOrientation0 As Single
        Public sngOrientation1 As Single
        Public sngOrientation2 As Single
        '   Acceleration 
        Public sngAcceleration0 As Single
        Public sngAcceleration1 As Single
        Public sngAcceleration2 As Single
        '   Velocity
        Public sngVelocity0 As Single
        Public sngVelocity1 As Single
        Public sngVelocity2 As Single
        '   Position
        Public bytPosition01 As Byte
        Public bytPosition02 As Byte
        Public bytPosition03 As Byte
        Public bytPosition04 As Byte
        Public bytPosition11 As Byte
        Public bytPosition12 As Byte
        Public bytPosition13 As Byte
        Public bytPosition14 As Byte
        Public bytPosition21 As Byte
        Public bytPosition22 As Byte
        Public bytPosition23 As Byte
        Public bytPosition24 As Byte
        '   Game ID - if specified in cfg.txt
        Public lngGameID As Long
    End Structure

    Private Sub Process_PacketRecieved(Text As String)
        'Clear Screen
        Console.Clear()

        ''Show the raw data - Uncomment this section for IL-2
        Console.WriteLine("Raw Data Is:") 'title
        Console.WriteLine(Text) 'Display Data - May get weird beeping if a structure is found - not sure why lol
        Console.WriteLine("") 'skip a line

        ''If your data is string delimited - do something like this - just an example
        'Dim ReturnedData As String() = Text.Split(",")
        ''Assign output
        'Console.WriteLine(ReturnedData(0))
        'Console.WriteLine(ReturnedData(1))
        'Console.WriteLine(ReturnedData(2))
        'Console.WriteLine(ReturnedData(3))
        'Console.WriteLine(ReturnedData(4))
        'Console.WriteLine(ReturnedData(5))

        ''Here is how to deal with a returned STRUCTURE (LFS Example) - this is the most complicated return IMO.- comment out this section for IL-2
        ''Edit Structure above to match incomming structure - then after the code below, assign output data
        ''Convert string to byte and copy to byte array
        'Dim ByteArray() As Byte = System.Text.Encoding.Default.GetBytes(Text)
        ''Create Gchandle instance and pin variable required
        'Dim MyGC As System.Runtime.InteropServices.GCHandle = System.Runtime.InteropServices.GCHandle.Alloc(MyOutsim_Internal, System.Runtime.InteropServices.GCHandleType.Pinned)
        ''get address of variable in pointer variable
        'Dim AddofLongValue As IntPtr = MyGC.AddrOfPinnedObject()
        ''Copy the memory space to my GCHandle
        'System.Runtime.InteropServices.Marshal.Copy(ByteArray, 0, AddofLongValue, ByteArray.Length)
        ''Direct Cast myGC to my Outsim Object
        'MyOutsim_Internal = DirectCast(MyGC.Target, OutSim)
        ''Free GChandle to avoid memory leaks
        'MyGC.Free()
        ''Get Proper Data out of UDP Packet
        'With MyOutsim_Internal
        '    Console.WriteLine(((System.Math.Cos(.sngOrientation0) * .sngAcceleration0) + (System.Math.Sin(.sngOrientation0) * .sngAcceleration1)) * -1)
        '    Console.WriteLine(((-System.Math.Sin(.sngOrientation0) * .sngAcceleration0) + (System.Math.Cos(.sngOrientation0) * .sngAcceleration1)) * -1)
        '    Console.WriteLine(System.Math.Cos(.sngOrientation2) * .sngAcceleration2)
        '    Console.WriteLine(((System.Math.Sin(.sngOrientation0) * .sngAcceleration0) + (System.Math.Sin(.sngOrientation0) * .sngAcceleration1)) * -1)
        '    Console.WriteLine((System.Math.Cos(.sngOrientation0) * .sngAcceleration0) + (System.Math.Sin(.sngOrientation0) * .sngAcceleration1))
        '    Console.WriteLine((-System.Math.Sin(.sngOrientation0) * .sngAcceleration0) + (System.Math.Cos(.sngOrientation0) * .sngAcceleration1))
        'End With
    End Sub

    Public Sub ReceiveMessages()
        Dim receiveBytes As [Byte]() = Client.Receive(RemoteIpEndPoint)
        Dim BitDet As BitArray = New BitArray(receiveBytes)
        Dim strReturnData As String = System.Text.Encoding.ASCII.GetString(receiveBytes)

        'returns the data as a string
        Process_PacketRecieved(strReturnData)

        'start new thread
        ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
        ThreadReceive.Start()
    End Sub
End Module
